//---------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#include <vcl\Registry.hpp>
#include <Clipbrd.hpp>
#include <mbstring.h>
#pragma hdrstop

#include "DescForm.h"
#include "MACCAPV2Lib_TLB.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDescriptionForm *DescriptionForm;
//---------------------------------------------------------------------------
__fastcall TDescriptionForm::TDescriptionForm(TComponent* Owner)
    : TForm(Owner), DumpWidth(4)
{
	TRegistry* reg = new TRegistry;
	if (reg->OpenKey("Software\\arton\\FreePeek\\DescForm", true))
	{
		try
		{
			Height = reg->ReadInteger("FormHeight");
			Width = reg->ReadInteger("FormWidth");
		}
		catch (const Exception &E)
		{
                        ;
		}
        reg->CloseKey();
	}
    delete reg;
}
//---------------------------------------------------------------------------
void __fastcall TDescriptionForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    TRegistry* reg = new TRegistry;
	if (reg->OpenKey("Software\\arton\\FreePeek\\DescForm", true))
	{
		try
		{
			reg->WriteInteger("FormHeight", Height);
			reg->WriteInteger("FormWidth", Width);
        }
        catch (const Exception &E)
        {
            ;
        }
    }
    delete reg;

    delete this;
}
//---------------------------------------------------------------------------
void __fastcall TDescriptionForm::DumpData(LPCSTR pb, int offset)
{
	char sz[384];
	while (*pb)
	{
		int n = wsprintf(sz, "%04X(%4d)  ", offset, offset);
		LPCSTR pbsave = pb;
		for (int i = 0; i < DumpWidth; i++)
		{
            for (int j = 0; j < 8; j++)
            {
                sz[n++] = (*pb) ? *pb++ : ' ';
			}
            sz[n++] = ' ';
		}
		pb = pbsave;
		sz[n++] = ' ';
		int max = DumpWidth * 4;
        char ach[3];
        ach[2] = '\0';
        char kj(0);
        int len;
		for (len = 0; *pb && len < max; len++)
		{
            ach[0] = *pb++;
            ach[1] = *pb++;
            char ch = static_cast<char>(strtoul(ach, NULL, 16));
            if (kj)
            {
                if (_ismbbtrail(ch))
                {
                    sz[n + len - 1] = kj;
                    sz[n + len] = ch;
                    kj = 0;
                    continue;
                }
                sz[n + len - 1] = '.';
                kj = 0;
            }
            if (_ismbblead(ch))
            {
                kj = ch;
            }
            else
            {
                if (_ismbbkana(ch))
                    sz[n + len] = ch;
                else if (isascii(ch))
                {
        			sz[n + len] = (isgraph(ch)) ? ch : ((isspace(ch)) ? ' ' : '.');
                }
                else
                    sz[n + len] = '.';
            }
		}
        if (kj)
            sz[n + len - 1] = '.';
		sz[n + len] = '\0';
		DataView->Lines->Append(sz);
		if (!*pb) break;
		offset += max;
	}
}
//---------------------------------------------------------------------------
void __fastcall TDescriptionForm::Print1Click(TObject *Sender)
{
    DataView->Print(Caption);
}
//---------------------------------------------------------------------------
void __fastcall TDescriptionForm::SelectAll1Click(TObject *Sender)
{
    DataView->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TDescriptionForm::Copy1Click(TObject *Sender)
{
    Clipboard()->AsText = DataView->SelText;
}
//---------------------------------------------------------------------------

