//---------------------------------------------------------------------------
// Copyright(c) 1999,2001 arton
//
#include <vcl.h>
#include "activscp.h"
#include <vcl\Registry.hpp>
#include <Clipbrd.hpp>
#pragma hdrstop
#include "DispForm.h"
#include "ip.h"
#include "FreePeekStrs.h"
#include "FreePeekMain.h"
#include "ListSearch.h"
#include "DescForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCapForm *CapForm;
//---------------------------------------------------------------------------
__fastcall TCapForm::TCapForm(TComponent* Owner)
    : TForm(Owner), nStart(-1), NoUpdate(false)
{
    ToolBarHeight = ToolBar1->Height;
    DumpWidth = DEF_WIDTH;
    TRegistry* reg = new TRegistry;
    DataFont = new TFont;
    bool fAssigned(false);
    if (reg->OpenKey("Software\\arton\\FreePeek\\Font", true))
    {
        try
        {
            DataFont->Height = reg->ReadInteger("Height");
            DataFont->Name = reg->ReadString("Name");
            DataFont->Pitch = (TFontPitch)reg->ReadInteger("Pitch");
            DataFont->Size = reg->ReadInteger("Size");
            fAssigned = true;
        }
        catch (const Exception &E)
        {
            ;
        }
        reg->CloseKey();
    }
    if (reg->OpenKey("Software\\arton\\FreePeek\\DataForm", true))
    {
    	try
    	{
    		Height = reg->ReadInteger("FormHeight");
    		Width = reg->ReadInteger("FormWidth");
    		Left = reg->ReadInteger("FormLeft");
    		Top = reg->ReadInteger("FormTop");
    		short asW[9];
    		reg->ReadBinaryData("ListCols", asW, sizeof(short) * 9);
    		for (int i = 0; i < 9; i++)
    		{
    			ListView->Columns->Items[i]->Width = asW[i];
    		}
            DumpWidth = reg->ReadInteger("DumpWidth");
        }
        catch (const Exception &E)
        {
            ;
        }
    }
    delete reg;
    if (fAssigned == false)
        DataFont->Assign(DataView->Font);
    TMenuItem* amen[] = {
        MenuN4, MenuN5, MenuN6, MenuN7, MenuN8, MenuN9, MenuN10, MenuN11,
    };
    for (int i = 0; i < COUNTOF(amen); i++)
    {
        if (DumpWidth == amen[i]->Tag)
        {
            amen[i]->Checked = true;
            break;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::SetPackets(IPacketCollectionPtr pColls, TProgressBar* pBar)
{
    NoUpdate = false;
    cbCaps = pColls->Length;
    int cbStep(cbCaps / 20);
    if (!cbStep) cbStep = cbCaps;
    IUnknown* pUnk = pColls->_NewEnum;
    IEnumVARIANT* pEnum;
    if (pUnk->QueryInterface(IID_IEnumVARIANT, (void**)&pEnum) == S_OK)
    {
        VARIANT v;
        IMacPacketEx* pPacket;
        HRESULT hr = S_OK;
        double ftPrior(0);
        for (int i = 1; hr == S_OK; i++)
		{
			VariantInit(&v);
			ULONG ulFetch;
			hr = pEnum->Next(1, &v, &ulFetch);
			if (hr == S_OK)
			{
				char sz[64];
				TListItem* item = ListView->Items->Add();
                v.pdispVal->QueryInterface(IID_IMacPacketEx, (void**)&pPacket);
                item->Data = pPacket;
        		__int64 ft;
				SYSTEMTIME st;
				pPacket->get_FileTime((CURRENCY*)&ft);
				ChangeFT(ft, st);
				wsprintf(sz, "%02d:%02d:%02d-%03d", st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
				item->Caption = sz;
				TStrings* ListItems = item->SubItems;
                AnsiString as;
				sz[8] = '\0';
                double df = ft / 10000.0;
				if (i == 1)
				{
                    as = "0.00\n";
				}
				else
				{
					ftPrior = df - ftPrior;
                    as = AnsiString::FloatToStrF(ftPrior, ffNumber, 15, 2) + "\n";
				}
				ftPrior = df;
				BSTR bstr;
				pPacket->get_DestMacString(&bstr);
                as += OleStrToString(bstr) + "\n";
				SysFreeString(bstr);
				pPacket->get_SrcMacString(&bstr);
                as += OleStrToString(bstr) + "\n";
				SysFreeString(bstr);

				long lEType, lSize;
				pPacket->get_EtherType(&lEType);
				pPacket->get_Length(&lSize);
				if (lEType == ET_ARP || lEType == ET_RARP)
				{
					pPacket->get_SrcIPAddressString(&bstr);
					AnsiString asSip = OleStrToString(bstr);
					if (lEType == ET_ARP)
					{
                        as += "ARP\n";
					}
					else
					{
                        as += "RARP\n";
					}
                    as += AnsiString(lSize) + "\n" + asSip + "\n";
					SysFreeString(bstr);
					pPacket->get_DestIPAddressString(&bstr);
                    as += OleStrToString(bstr) + "\n";
					SysFreeString(bstr);
				}
				else if (lEType == ET_IP)
				{
					short sProto;
                    as += "IP\n" + AnsiString(lSize) + "\n";
					pPacket->get_SrcIPAddressString(&bstr);
                    as += OleStrToString(bstr) + "\n";
					SysFreeString(bstr);
					pPacket->get_DestIPAddressString(&bstr);
                    as += OleStrToString(bstr) + "\n";
					SysFreeString(bstr);
					pPacket->get_InternetProtocolString(&bstr);
					as += OleStrToString(bstr);
					SysFreeString(bstr);
					pPacket->get_InternetProtocol(&sProto);
					VARIANT vData;
					VariantInit(&vData);
					if (pPacket->get_Value((TVariant*)&vData) == S_OK && vData.vt == (VT_ARRAY | VT_UI1))
					{
						SafeArrayLock(vData.parray);
						LPBYTE pb = (LPBYTE)vData.parray->pvData;
						pb += MAC_HLEN;
						pb += (*pb & 0x0f) * sizeof(long);
						switch (sProto)
						{
						case ICMP:
							as += " (";
							as += GetICMPTypeName(*pb);
							as += ")";
							break;
						case UDP:
							as += " (" + GetUDPInfo(pb) + ")";
							break;
						case TCP:
							as += " (" + GetTCPInfo(pb) + ")";
							break;
						case OSPFIGP:
							as += " (" + GetOSPFInfo(pb) + ")";
							break;
						default:
							break;
						}
						SafeArrayUnlock(vData.parray);
						VariantClear(&vData);
					}
				}
				else
				{
					pPacket->get_EtherTypeString(&bstr);
                    as += OleStrToString(bstr) + "\n" + AnsiString(lSize) + "\n";
					SysFreeString(bstr);
				}
                ListItems->SetText(as.c_str());

				VariantClear(&v);
			}
            if (i % cbStep == 0)
                pBar->StepIt();
		}
        pEnum->Release();
        ListView->Selected = ListView->Items->Item[0];
    }
    pUnk->Release();
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ChangeFT(__int64& ft, SYSTEMTIME& st)
{
	ft /= 100;
	ft *= 100;
	FILETIME ftime;
	FileTimeToLocalFileTime((FILETIME*)&ft, &ftime);
	FileTimeToSystemTime(&ftime, &st);
}
//----------------------------------------------------------------------------
void __fastcall TCapForm::PrintDump(int n, int pos, int len)
{
    IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(ListView->Items->Item[n]->Data);
    IRawMacPacket* pRaw;
    if (pPacket->QueryInterface(IID_IRawMacPacket, (void**)&pRaw) == S_OK)
    {
        PrintDump(DataView->Lines, pRaw, pos, len);
        pRaw->Release();
    }
    ShowIndex(n);
}
//----------------------------------------------------------------------------
void __fastcall TCapForm::PrintDump(TListItem* p)
{
    IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(p->Data);
    IRawMacPacket* pRaw;
    if (pPacket->QueryInterface(IID_IRawMacPacket, (void**)&pRaw) == S_OK)
    {
        PrintDump(DataView->Lines, pRaw);
        pRaw->Release();
    }
    ShowIndex(p->Index);
}
//----------------------------------------------------------------------------
void __fastcall TCapForm::PrintDump(TStrings* DumpList, IRawMacPacket* pRaw, int seloffset, int sellength)
{
    DumpList->BeginUpdate();
    DumpList->Clear();
    BYTE buff[2048];
    int len(sizeof(buff));
    int NewSelPos(-1);
    if (pRaw->GetPacket(reinterpret_cast<long*>(&len), buff) == S_OK)
    {
        DumpList->Append("MAC Header: 14");
        DumpData(buff, MAC_HLEN, 0, DumpList, seloffset, sellength, NewSelPos);
        len -= MAC_HLEN;
        seloffset -= MAC_HLEN;
        if (MAKEWORD(buff[13], buff[12]) != ET_IP)
		{
			DumpList->Append("\r\nData: " + IntToStr(len));
			DumpData(&buff[MAC_HLEN], len, 0, DumpList, seloffset, sellength, NewSelPos);
        }
        else
        {
            int off = MAC_HLEN;
            int hlen = (buff[off] & 0x0f) * sizeof(long);
            BYTE proto = buff[off + 9];
            DumpList->Append("\r\nIP Header: " + IntToStr(hlen));
            DumpData(&buff[off], hlen, 0, DumpList, seloffset, sellength, NewSelPos);
            off += hlen;
            seloffset -= hlen;
            len -= hlen;
            if (len > 0)
            {
                switch (proto)
                {
                case TCP:
                    hlen = ((buff[off + 12]) >> 4) * sizeof(long);
                    DumpList->Append("\r\nTCP Header: " + IntToStr(hlen));
                    break;
                case UDP:
                    hlen = 8;
                    DumpList->Append("\r\nUDP Header: " + IntToStr(hlen));
                    break;
                case OSPFIGP:
                    hlen = 24;
                    DumpList->Append("\r\nOSPF Header: " + IntToStr(hlen));
                    break;
                default:
                    hlen = 0;
                    break;
                }
                if (hlen)
                {
                    DumpData(&buff[off], hlen, 0, DumpList, seloffset, sellength, NewSelPos);
                    len -= hlen;
                    off += hlen;
                    seloffset -= hlen;
                }
                if (len > 0)
                {
                    DumpList->Append("\r\nData: " + IntToStr(len));
                    DumpData(&buff[off], len, 0, DumpList, seloffset, sellength, NewSelPos);
                }
            }
		}
        if (NewSelPos >= 0)
        {
            DataView->SelStart = NewSelPos;
            DataView->SetFocus();
        }
    }
    DumpList->EndUpdate();
}
//----------------------------------------------------------------------------
void __fastcall TCapForm::DumpData(LPBYTE pb, int len, int offset, TStrings* ss, int seloffset, int sellength, int& NewPos)
{
    if (sellength == 0)
        return DumpData(pb, len, offset, ss);
    int ofst(0);
    int aofst(0);
    int selend(seloffset + sellength);
	char sz[384];
    bool fColorChanged(false);
	while (len)
	{
		int n = wsprintf(sz, "\r\n%04X(%4d)  ", offset, offset);
		int lensave = len;
		LPBYTE pbsave = pb;
		for (int i = 0; i < DumpWidth; i++)
		{
			if (len > 0)
			{
                fColorChanged = false;
				for (int j = 0; j < 4; j++)
				{
					if (j < len)
					{
                        if (fColorChanged == false && ofst >= seloffset && ofst < selend)
                        {
                            if (n)
                            {
                                sz[n] = '\0';
                                DataView->SelText = sz;
                            }
                            DataView->SelAttributes->Color = clRed;
                            n = 0;
                            fColorChanged = true;
                            if (NewPos < 0)
                                NewPos = DataView->SelStart;
                        }
                        else if (fColorChanged && ofst == selend)
                        {
                            if (n)
                            {
                                sz[n] = '\0';
                                DataView->SelText = sz;
                            }
                            DataView->SelAttributes->Color = clWindowText;
                            n = 0;
                            fColorChanged = false;
                        }
						n += wsprintf(&sz[n], "%02X", *pb++);
                        ofst++;
					}
					else
					{
						sz[n] = sz[n + 1] = ' ';
						n += 2;
					}
				}
                if (n)
                {
                    sz[n] = '\0';
                    DataView->SelText = sz;
                    n = 0;
                }
                DataView->SelAttributes->Color = clWindowText;
                fColorChanged = false;

				sz[n++] = ' ';
                len -= 4;
                if (len < 0) len = 0;
			}
			else
			{
				memset(&sz[n], ' ', 9);
				n += 9;
			}
		}

		pb = pbsave;
		len = lensave;
		sz[n++] = ' ';
		int max = DumpWidth * 4;
		if (max > len) max = len;
        fColorChanged = false;
		for (int i = 0; i < max; i++)
		{
            if (fColorChanged == false && aofst >= seloffset && aofst < selend)
            {
                if (n)
                {
                    sz[n] = '\0';
                    DataView->SelText = sz;
                }
                DataView->SelAttributes->Color = clRed;
                n = 0;
                fColorChanged = true;
            }
            else if (fColorChanged && aofst == selend)
            {
                if (n)
                {
                    sz[n] = '\0';
                    DataView->SelText = sz;
                }
                DataView->SelAttributes->Color = clWindowText;
                n = 0;
                fColorChanged = false;
            }
			sz[n++] = (isgraph(*(pb + i))) ? *(pb + i) : ((isspace(*(pb + i))) ? ' ' : '.');
            aofst++;
		}
		sz[n] = '\0';
		DataView->SelText = sz;
        DataView->SelAttributes->Color = clWindowText;
		if (len <= max) break;
		pb += max;
		len -= max;
	}
}
//----------------------------------------------------------------------------
void __fastcall TCapForm::DumpData(LPBYTE pb, int len, int offset, TStrings* ss)
{
	char sz[384];
	while (len)
	{
		int n = wsprintf(sz, "%04X(%4d)  ", offset, offset);
		int lensave = len;
		LPBYTE pbsave = pb;
		for (int i = 0; i < DumpWidth; i++)
		{
			if (len >= 4)
			{
				n += wsprintf(&sz[n], "%02X%02X%02X%02X ", *pb, *(pb + 1), *(pb + 2), *(pb + 3));
				len -= 4;
				pb += 4;
			}
			else if (len > 0)
			{
				for (int i = 0; i < 4; i++)
				{
					if (i < len)
					{
						n += wsprintf(&sz[n], "%02X", *(pb + i));
					}
					else
					{
						sz[n] = sz[n + 1] = ' ';
						n += 2;
					}
				}
				sz[n++] = ' ';
				len = 0;
			}
			else
			{
				memset(&sz[n], ' ', 9);
				n += 9;
			}
		}
		pb = pbsave;
		len = lensave;
		sz[n++] = ' ';
		int max = DumpWidth * 4;
		if (max > len) max = len;
		for (int i = 0; i < max; i++)
		{
			sz[n + i] = (isgraph(*(pb + i))) ? *(pb + i) : ((isspace(*(pb + i))) ? ' ' : '.');
		}
		sz[n + max] = '\0';
		ss->Append(sz);
		if (len <= max) break;
		offset += max;
		pb += max;
		len -= max;
	}
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionCloseExecute(TObject *Sender)
{
    PostMessage(Handle, WM_CLOSE, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::Panel1DockDrop(TObject *Sender,
      TDragDockObject *Source, int X, int Y)
{
    Panel1->Height = ToolBarHeight;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    TRegistry* reg = new TRegistry;
    if (reg->OpenKey("Software\\arton\\FreePeek\\DataForm", true))
    {
        try
        {
            reg->WriteInteger("FormLeft", Left);
            reg->WriteInteger("FormTop", Top);
            reg->WriteInteger("FormHeight", Height);
            reg->WriteInteger("FormWidth", Width);
            short asW[9];
            for (int i = 0; i < 9; i++)
            {
                asW[i] = (short)ListView->Columns->Items[i]->Width;
            }
            reg->WriteBinaryData("ListCols", asW, 9 * sizeof(short));
            reg->WriteInteger("DumpWidth", DumpWidth);
        }
        catch (const Exception &E)
        {
            ;
        }
    }
    delete reg;
    TListItems* pItems = ListView->Items;
    for (int i = 0; i < pItems->Count; i++)
    {
        IUnknown* pUnk = reinterpret_cast<IUnknown*>(pItems->Item[i]->Data);
        pUnk->Release();
    }
    delete DataFont;
    delete this;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionDownExecute(TObject *Sender)
{
    RowMove(sdBelow);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionUpExecute(TObject *Sender)
{
    RowMove(sdAbove);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::RowMove(TSearchDirection dir)
{
	TItemStates s;
	s << isNone;
    TListItem* p = ListView->GetNextItem(ListView->Selected, dir, s);
    if (p)
    {
        ListView->Selected = p;
        p->MakeVisible(false);
        if (ListView->Focused() == false)
            ListView->SetFocus();
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ListViewSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
    if (Selected && NoUpdate == false)
        PrintDump(Item);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionUpUpdate(TObject *Sender)
{
	TItemStates s;
	s << isNone;
    TListItem* p = ListView->GetNextItem(ListView->Selected, sdAbove, s);
    static_cast<TAction*>(Sender)->Enabled = (p) ? true : false;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionDownUpdate(TObject *Sender)
{
	TItemStates s;
	s << isNone;
    TListItem* p = ListView->GetNextItem(ListView->Selected, sdBelow, s);
    static_cast<TAction*>(Sender)->Enabled = (p) ? true : false;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionCopyUpdate(TObject *Sender)
{
    static_cast<TAction*>(Sender)->Enabled = (DataView->SelLength <= 0) ? false : true;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionCopyExecute(TObject *Sender)
{
    Clipboard()->AsText = DataView->SelText;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionFontExecute(TObject *Sender)
{
	FontDialog->Font->Assign(DataView->Font);
	if (FontDialog->Execute())
	{
        delete DataFont;
        DataFont = new TFont;
        DataFont->Assign(FontDialog->Font);
		DataView->Font->Assign(DataFont);
		TRegistry* reg = new TRegistry;
		if (reg->OpenKey("Software\\arton\\FreePeek\\Font", true))
		{
			try
			{
				reg->WriteInteger("Height", DataFont->Height);
				reg->WriteString("Name", DataFont->Name);
				reg->WriteInteger("Pitch", DataFont->Pitch);
				reg->WriteInteger("Size", DataFont->Size);
			}
			catch (const Exception &E)
			{
				;
			}
			reg->CloseKey();
		}
		delete reg;
        DataView->Refresh();
	}
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::FormShow(TObject *Sender)
{
    DataView->Font->Assign(DataFont);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::FormActivate(TObject *Sender)
{
	Application->OnHint = ShowHint;
}

//---------------------------------------------------------------------------
void __fastcall TCapForm::ShowHint(TObject *Sender)
{
	StatusBar->Panels->Items[0]->Text = Application->Hint;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ShowIndex(int n)
{
    char sz[32];
    wsprintf(sz, "Packet: %d/%d", n + 1, cbCaps);
    StatusBar->Panels->Items[2]->Text = sz;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::FormDeactivate(TObject *Sender)
{
	StatusBar->Panels->Items[0]->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionFileSaveExecute(TObject *Sender)
{
    String str;
    TVarRec vrs[1];
    SaveDialog->Filter = LoadStr(rsCaptureTypeExt);
    SaveDialog->FileName = FileName;
    SaveDialog->DefaultExt = "ncp";
    if (SaveDialog->Execute())
    {
        if (FileExists(SaveDialog->FileName))
        {
            str = FmtLoadStr(sOverwrite, OPENARRAY(TVarRec, (SaveDialog->FileName)));
	    if (MessageDlg(str, mtConfirmation, TMsgDlgButtons() << mbYes << mbNo <<
	    	mbCancel, 0) != IDYES)
	        return;
        }
        FileName = SaveDialog->FileName;
        int nExt = FileName.LastDelimiter(".");
        AnsiString ext("ncp");
        if (nExt == 0)
        {
            FileName = FileName + "." + ext;
        }
        else
        {
            nExt++;
            ext = FileName.SubString(nExt, FileName.Length() - nExt + 1);
        }
        if (ext.AnsiCompareIC("TXT") == 0)
        {
            TStringList* DumpList = new TStringList;
            try
            {
                TFileStream* Stm = new TFileStream(FileName, fmCreate | fmShareDenyWrite);
                SaveText(Stm, DumpList, true);
                delete Stm;
            }
            catch (const Exception &E)
            {
                ShowMessage(AnsiString(E.ClassName())+ E.Message);
            }
            delete DumpList;
        }
        else if (ext.AnsiCompareIC("CSV") == 0)
        {
            try
            {
                TFileStream* Stm = new TFileStream(FileName, fmCreate | fmShareDenyWrite);
                SaveCSV(Stm, true);
                delete Stm;
            }
            catch (const Exception &E)
            {
			    ShowMessage(AnsiString(E.ClassName())+ E.Message);
            }
        }
        else
        {
            WideString ws(FileName);
            MainForm->SaveCapture(ws);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionFindExecute(TObject *Sender)
{
    TPoint pnt = Mouse->CursorPos;
    TSearchDlg* SearchDlg = new TSearchDlg(this);
    SearchDlg->Top = pnt.y;
    SearchDlg->Left = pnt.x;
    if (SearchDlg->ShowModal() == IDOK)
    {
        switch (SearchDlg->GetIndex())
        {
        case 0:
            pFunc = &TCapForm::SearchItemTime;
            target = SearchDlg->GetTarget();
            break;
        case 1:
            pFunc = &TCapForm::SearchItemIP;
            target = SearchDlg->GetTarget();
            break;
        case 2:
            pFunc = &TCapForm::SearchData;
            target = SearchDlg->GetTarget();
        case 3:
            pFunc = &TCapForm::SearchData;
            target = Pack(SearchDlg->GetTarget());
            break;
        default:
            return;
        }
        TListItem* pItem = ListView->Selected;
        nStart = (pItem) ? pItem->Index : 0;
        PrintSearchedItem();
        if (nStart >= 0)
            StatusBar->Panels->Items[1]->Text = LoadStr(rsSearchTime + SearchDlg->GetIndex()) + SearchDlg->GetTarget();
        else
            MessageBeep(0);            
    }
    delete SearchDlg;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCapForm::Pack(AnsiString& s)
{
    char sz[8];
    AnsiString ret;
    for (int i = 1; i <= s.Length(); i++)
    {
        BYTE b = s[i];
        wsprintf(sz, "%02X", b);
        ret += sz;
    }
    return ret;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionFindNextExecute(TObject *Sender)
{
    if (nStart < 0)
    {
        TListItem* pItem = ListView->Selected;
        nStart = (pItem) ? pItem->Index : 0;
    }
    PrintSearchedItem();
}
//---------------------------------------------------------------------------
void TCapForm::PrintSearchedItem()
{
    TListItems* pItems = ListView->Items;
    int col(-1);

    int idx = (this->*pFunc)(nStart, pItems->Count, target, col);
    if (idx < 0)
    {
        idx = (this->*pFunc)(0, nStart, target, col);
    }
    if (idx >= 0)
    {
        pItems->Item[idx]->MakeVisible(true);
        pItems->Item[idx]->Checked = true;
        if (col >= 0)
        {
            PrintDump(idx, col, target.Length() / 2);
        }
        else
        {
            PrintDump(idx);
        }
        NoUpdate = true;
        ListView->SetFocus();
        ListView->Selected = pItems->Item[idx];
        NoUpdate = false;
        idx++;
        if (idx >= pItems->Count)
            idx = 0;
    }
    nStart = idx;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionFindNextUpdate(TObject *Sender)
{
    static_cast<TAction*>(Sender)->Enabled = (nStart >= 0) ? true : false;
}
//---------------------------------------------------------------------------
int TCapForm::SearchData(int start, int end, AnsiString& str, int& col)
{
    TListItems* pItems = ListView->Items;
    for (int i = start; i < end; i++)
    {
        IMacPacketEx* pPacket = reinterpret_cast<IMacPacketEx*>(pItems->Item[i]->Data);
        BSTR bstr = NULL;
        if (pPacket->get_UnpackedString(&bstr) == S_OK && bstr)
        {
            AnsiString s(bstr);
            int pos = s.Pos(str);
            SysFreeString(bstr);
            if (pos)
            {
                col = (pos - 1) / 2;
                return i;
            }
        }
    }
    return -1;
}
//---------------------------------------------------------------------------
int TCapForm::SearchItemIP(int start, int end, AnsiString& str, int&)
{
    TListItems* pItems = ListView->Items;
    for (int i = start; i < end; i++)
    {
        TStrings* ps = pItems->Item[i]->SubItems;
        if (ps->Strings[5].AnsiCompare(str) == 0
            || ps->Strings[6].AnsiCompare(str) == 0)
        {
            return i;
        }
    }
    return -1;
}
//---------------------------------------------------------------------------
int TCapForm::SearchItemTime(int start, int end, AnsiString& str, int&)
{
    TListItems* pItems = ListView->Items;
    for (int i = start; i < end; i++)
    {
        int match = pItems->Item[i]->Caption.AnsiCompare(str);
        if (match == 0
            || (match > 0 && pItems->Item[i]->Caption.SubString(1, 5).AnsiCompare(str.SubString(1, 5)) == 0))
        {
            return i;
        }
    }
    return -1;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::FormResize(TObject *Sender)
{
    int must = StatusBar->Panels->Items[1]->Width + StatusBar->Panels->Items[2]->Width;
    StatusBar->Panels->Items[0]->Width = (must > ClientWidth) ? 0 : ClientWidth - must;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionSelFileSaveExecute(TObject *Sender)
{
    String str;
    TVarRec vrs[1];
    SaveDialog->Filter = LoadStr(rsTextTypeExt);
    SaveDialog->FileName = FileName;
    SaveDialog->DefaultExt = "txt";
    if (SaveDialog->Execute())
    {
    	if (FileExists(SaveDialog->FileName))
    	{
    	    str = FmtLoadStr(sOverwrite, OPENARRAY(TVarRec, (SaveDialog->FileName)));
	    if (MessageDlg(str, mtConfirmation, TMsgDlgButtons() << mbYes << mbNo <<
	    	mbCancel, 0) != IDYES)
	    	return;
        }
        FileName = SaveDialog->FileName;
        int nExt = FileName.LastDelimiter(".");
        AnsiString ext("txt");
        if (nExt == 0)
        {
            FileName = FileName + "." + ext;
        }
        else
        {
            nExt++;
            ext = FileName.SubString(nExt, FileName.Length() - nExt + 1);
        }
        if (ext.AnsiCompareIC("TXT") == 0)
        {
            TStringList* DumpList = new TStringList;
            try
	    {
	    	TFileStream* Stm = new TFileStream(FileName, fmCreate | fmShareDenyWrite);
                SaveText(Stm, DumpList, false);
	    	delete Stm;
	    }
	    catch (const Exception &E)
	    {
                ShowMessage(AnsiString(E.ClassName())+ E.Message);
	    }
            delete DumpList;
        }
        else if (ext.AnsiCompareIC("CSV") == 0)
        {
            try
            {
                TFileStream* Stm = new TFileStream(FileName, fmCreate | fmShareDenyWrite);
                SaveCSV(Stm, false);
                delete Stm;
            }
            catch (const Exception &E)
            {
			    ShowMessage(AnsiString(E.ClassName())+ E.Message);
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::SaveText(TFileStream* Stm, TStrings* DumpList, bool SaveAll)
{
    TListItems* Root = ListView->Items;
    int packets = Root->Count - 1;
    for (int nd = 0; nd <= packets; nd++)
    {
        TListItem* pItem = Root->Item[nd];
        if (!SaveAll)
            if (pItem->Checked == false) continue;
        AnsiString as(GetTextTitle(pItem));
        Stm->Write(as.c_str(), as.Length());
        Stm->Write("\r\n", 2);
#if 0
        if (nd % 20 == 0)
        {
            char sz[64];
            wsprintf(sz, "Writing...%d/%d", nd, packets);
            StatusLine->Panels->Items[SL_STAT]->Text = sz;
        }
#endif
        IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(Root->Item[nd]->Data);
        if (pPacket)
        {
            IRawMacPacket* pRaw;
            if (pPacket->QueryInterface(IID_IRawMacPacket, (void**)&pRaw) == S_OK)
            {
                PrintDump(DumpList, pRaw);
                pRaw->Release();
            }
        }
        if (nd != packets)
            DumpList->Append(AnsiString::StringOfChar('-', 80));
        DumpList->SaveToStream(Stm);
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::SaveCSV(TFileStream* Stm, bool SaveAll)
{
    AnsiString szTitle = LoadStr(rsCSVTitle);

    Stm->Write(szTitle.c_str(), szTitle.Length());	// -1 for NULL Terminator
    TListItems* Root = ListView->Items;
    int packets = Root->Count;
    for (int item = 0; item < packets; item++)
    {
        TListItem* pItem = Root->Item[item];
        if (!SaveAll)
            if (pItem->Checked == false) continue;
        AnsiString as(pItem->Caption);
        as += "," + pItem->SubItems->CommaText;
        Stm->Write(as.c_str(), as.Length());
        Stm->Write("\r\n", 2);
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionUncheckExecute(TObject *Sender)
{
    TListItems* Root = ListView->Items;
    int packets = Root->Count;
    for (int item = 0; item < packets; item++)
    {
        Root->Item[item]->Checked = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionSelConnectionUpdate(TObject *Sender)
{
    bool f(false);
    TListItem* pItem = ListView->Selected;
    if (pItem)
    {
        IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(pItem->Data);
        short s;
        pPacket->get_InternetProtocol(&s);
        if (s == TCP)
            f = true;
    }
    static_cast<TAction*>(Sender)->Enabled = f;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCapForm::GetTextTitle(TListItem* pItem)
{
    AnsiString as(pItem->Caption);
    as += " DST:" + pItem->SubItems->Strings[1];
    as += " SRC:" + pItem->SubItems->Strings[2];
    as += " (" + pItem->SubItems->Strings[3];
    as += ")";
    if (pItem->SubItems->Count > 7)
    {
        as += " " + pItem->SubItems->Strings[7];
    }
    return as;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionSaveThisExecute(TObject *Sender)
{
    TListItem* pItem = ListView->Selected;
    if (!pItem) return;

    AnsiString filename(pItem->Caption);
    for (int i = 1; i <= filename.Length(); i++)
    {
        if (filename[i] == ':')
            filename[i] = '-';
    }
    String str;
    TVarRec vrs[1];
    SaveDialog->Filter = LoadStr(rsPacketTypeExt);
    SaveDialog->FileName = filename;
    SaveDialog->DefaultExt = "bin";
    if (SaveDialog->Execute())
    {
    	if (FileExists(SaveDialog->FileName))
    	{
    		str = FmtLoadStr(sOverwrite, OPENARRAY(TVarRec, (SaveDialog->FileName)));
    		if (MessageDlg(str, mtConfirmation, TMsgDlgButtons() << mbYes << mbNo <<
    			mbCancel, 0) != IDYES)
    			return;
    	}
    	filename = SaveDialog->FileName;
        int nExt = filename.LastDelimiter(".");
        AnsiString ext("bin");
        if (nExt == 0)
        {
            filename = filename + "." + ext;
        }
        else
        {
            nExt++;
            ext = filename.SubString(nExt, filename.Length() - nExt + 1);
        }
        if (ext.AnsiCompareIC("TXT") == 0)
	{
            try
	    {
	    	TFileStream* Stm = new TFileStream(filename, fmCreate | fmShareDenyWrite);
                AnsiString as(GetTextTitle(pItem));
                Stm->Write(as.c_str(), as.Length());
                Stm->Write("\r\n", 2);
                DataView->Lines->SaveToStream(Stm);
	    	delete Stm;
	    }
	    catch (const Exception &E)
	    {
                ShowMessage(AnsiString(E.ClassName())+ E.Message);
	    }
        }
        else if (ext.AnsiCompareIC("BIN") == 0)
        {
            try
            {
                TFileStream* Stm = new TFileStream(filename, fmCreate | fmShareDenyWrite);
                IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(pItem->Data);
                IRawMacPacket* pRaw;
                if (pPacket->QueryInterface(IID_IRawMacPacket, (void**)&pRaw) == S_OK)
                {
                    unsigned char buff[2048];
                    long lLen(sizeof(buff));
                    pRaw->GetPacket(&lLen, buff);
                    Stm->Write(buff, lLen);
                    pRaw->Release();
                }
                delete Stm;
            }
            catch (const Exception &E)
            {
                ShowMessage(AnsiString(E.ClassName())+ E.Message);
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::RowMoveChecked(TSearchDirection dir)
{
	TItemStates s;
	s << isNone;
    TListItem* p = ListView->Selected;
    while (p)
    {
        p = ListView->GetNextItem(p, dir, s);
        if (p && p->Checked)
        {
            ListView->Selected = p;
            p->MakeVisible(false);
            if (ListView->Focused() == false)
                ListView->SetFocus();
            return;
        }
    }
    MessageBeep(0);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionUpCheckedExecute(TObject *Sender)
{
    RowMoveChecked(sdAbove);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionDownCheckedExecute(TObject *Sender)
{
    RowMoveChecked(sdBelow);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionPrintThisExecute(TObject *Sender)
{
    DataView->Print(FileName);
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionSelectAllExecute(TObject *Sender)
{
    DataView->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionChangeWidthExecute(TObject *Sender)
{
    TMenuItem* pSender = static_cast<TMenuItem*>(Sender);
    if (DumpWidth != pSender->Tag)
    {
        pSender->Checked = true;
        DumpWidth = pSender->Tag;
        PrintDump(ListView->Selected);
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionDescriptionExecute(TObject *Sender)
{
    TListItem* pItem = ListView->Selected;
    IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(pItem->Data);
    TDescriptionForm* pForm = new TDescriptionForm(this);
    pForm->Caption = pItem->Caption;
    pForm->Show();
    MainForm->SetDescForm(pForm);
    MainForm->SiteObject.ShowPacket(pPacket);
    pForm->DataView->SelStart = 0;
    pForm->DataView->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionDescriptionUpdate(TObject *Sender)
{
    static_cast<TAction*>(Sender)->Enabled = MainForm->ScriptAvail();
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionDescAllExecute(TObject *Sender)
{
    TListItems* Root = ListView->Items;
    int packets = Root->Count;
    for (int item = packets - 1; item >= 0; item--)
    {
        TListItem* pItem = Root->Item[item];
        if (pItem->Checked == false) continue;
        IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(pItem->Data);
        TDescriptionForm* pForm = new TDescriptionForm(this);
        pForm->Caption = pItem->Caption;
        pForm->Show();
        MainForm->SetDescForm(pForm);
        MainForm->SiteObject.ShowPacket(pPacket);
        pForm->DataView->SelStart = 0;
        pForm->DataView->SetFocus();
        Application->ProcessMessages();
    }
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::ActionSelConnectionExecute(TObject *Sender)
{
    TListItem* pItem = ListView->Selected;
    if (!pItem) return;
    pItem->Checked = true;

    DWORD dwSrcAddr, dwDstAddr, dwSeq, dwAck;
    WORD sSrcPort, sDstPort;

    if (GetTcpInfo(pItem, dwSrcAddr, dwDstAddr, sSrcPort, sDstPort, dwSeq, dwAck))
    {
        CheckConnection(pItem->Index, dwSrcAddr, dwDstAddr, sSrcPort, sDstPort, dwSeq, dwAck, false);
        CheckConnection(pItem->Index, dwSrcAddr, dwDstAddr, sSrcPort, sDstPort, dwSeq, dwAck, true);
    }
}
//---------------------------------------------------------------------------
bool __fastcall TCapForm::GetTcpInfo(TListItem* pItem, DWORD& dwSrcAddr, DWORD& dwDstAddr,
    WORD& sSrcPort, WORD& sDstPort, DWORD& dwSeq, DWORD& dwAck)
{
    IRawMacPacket* pRaw;
    IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(pItem->Data);
    if (pPacket->QueryInterface(IID_IRawMacPacket, (void**)&pRaw) != S_OK)
        return false;

    long len;
    BYTE ab[2048];
    pRaw->GetPacket(&len, ab);
    CopyMemory(&dwSrcAddr, &ab[MAC_HLEN + 12], sizeof(DWORD));
    CopyMemory(&dwDstAddr, &ab[MAC_HLEN + 16], sizeof(DWORD));
    int iph = MAC_HLEN + (ab[MAC_HLEN] & 0x0f) * sizeof(DWORD);
    CopyMemory(&sSrcPort, &ab[iph], sizeof(WORD));
    iph += sizeof(WORD);
    CopyMemory(&sDstPort, &ab[iph], sizeof(WORD));
    iph += sizeof(WORD);
    CopyMemory(&dwSeq, &ab[iph], sizeof(DWORD));
    iph += sizeof(DWORD);
    CopyMemory(&dwAck, &ab[iph], sizeof(DWORD));
    pRaw->Release();
    return true;
}
//---------------------------------------------------------------------------
void __fastcall TCapForm::CheckConnection(int base, DWORD SrcAddr, DWORD DstAddr,
    WORD SrcPort, WORD DstPort, DWORD Seq, DWORD Ack, bool up)
{
    TListItems* Root = ListView->Items;
    int start = (up) ? base + 1 : base - 1;
    for (int i = start;;)
    {
        if (up && i >= Root->Count) break;
        else if (!up && i < 0) break;

        TListItem* pItem = Root->Item[i];
        IMacPacket* pPacket = reinterpret_cast<IMacPacket*>(pItem->Data);
        pItem->Checked = false;
        short s;
        pPacket->get_InternetProtocol(&s);
        if (s == TCP)
        {
            DWORD dwSrcAddr, dwDstAddr, dwSeq, dwAck;
            WORD sSrcPort, sDstPort;

            if (GetTcpInfo(pItem, dwSrcAddr, dwDstAddr, sSrcPort, sDstPort, dwSeq, dwAck))
            {
                if (dwSrcAddr == SrcAddr && dwDstAddr == DstAddr
                    && SrcPort == sSrcPort && DstPort == sDstPort)
                {
                    pItem->Checked = true;
                }
                else if (dwSrcAddr == DstAddr && dwDstAddr == SrcAddr
                    && SrcPort == sDstPort && DstPort == sSrcPort)
                {
                    pItem->Checked = true;
                }
            }
        }
        if (up) i++;
        else i--;
    }
}
//---------------------------------------------------------------------------

