// Copyright(c) 1999 arton

/*
 Original Text from 

http://www.cavebear.com/CaveBear/Ethernet/type.html
$Revision: 2.11 $
$Date: 1998/04/11 21:44:57 $
$Author: map $
$Id: type.html,v 2.11 1998/04/11 21:44:57 map Exp $

  By Michael Patton (http://map-ne.com/)
*/

#include <stdafx.h>
#include "MacCapv2.h"
#include "AssNum.h"

const static SEtherType etypes[] = {
  { 0, 0x600, L"IEEE802.3 Length Field (0.:1500.)", },
  { 0x0601, 0x0601, L"XNS Address Translation (3Mb only)", },
  { 0x0800, 0x0800, L"DOD Internet Protocol (IP)", },
  { 0x0801, 0x0801, L"X.75 Internet", },
  { 0x0802, 0x0802, L"NBS Internet", },
  { 0x0803, 0x0803, L"ECMA Internet", },
  { 0x0804, 0x0804, L"CHAOSnet", },
  { 0x0805, 0x0805, L"X.25 Level 3", },
  { 0x0806, 0x0806, L"Address Resolution Protocol (ARP) (for IP and for CHAOS)", },
  { 0x0807, 0x0807, L"XNS Compatibility", },
  { 0x081C, 0x081C, L"Symbolics Private", },
  { 0x0888, 0x088A, L"Xyplex", },
  { 0x0900, 0x0900, L"Ungermann-Bass network debugger", },
  { 0x0A00, 0x0A00, L"Xerox IEEE802.3 PUP", },
  { 0x0A01, 0x0A01, L"Xerox IEEE802.3 PUP Address Translation", },
  { 0x0BAD, 0x0BAD, L"Banyan Systems", },
  { 0x0BAF, 0x0BAF, L"Banyon VINES Echo", },
  { 0x1000, 0x1000, L"Berkeley Trailer negotiation", },
  { 0x1001, 0x100F, L"Berkeley Trailer encapsulation for IP", },
  { 0x1234, 0x1234, L"DCA - Multicast", },
  { 0x1600, 0x1600, L"VALID system protocol", },
  { 0x1989, 0x1989, L"Artificial Horizons (\"Aviator\" dogfight simulator [on Sun])", },
  { 0x1995, 0x1995, L"Datapoint Corporation (RCL lan protocol)", },
  { 0x3C00, 0x3C00, L"3Com NBP virtual circuit datagram (like XNS SPP) not registered", },
  { 0x3C01, 0x3C01, L"3Com NBP System control datagram not registered", },
  { 0x3C02, 0x3C02, L"3Com NBP Connect request (virtual cct) not registered", },
  { 0x3C03, 0x3C03, L"3Com NBP Connect repsonse not registered", },
  { 0x3C04, 0x3C04, L"3Com NBP Connect complete not registered", },
  { 0x3C05, 0x3C05, L"3Com NBP Close request (virtual cct) not registered", },
  { 0x3C06, 0x3C06, L"3Com NBP Close response not registered", },
  { 0x3C07, 0x3C07, L"3Com NBP Datagram (like XNS IDP) not registered", },
  { 0x3C08, 0x3C08, L"3Com NBP Datagram broadcast not registered", },
  { 0x3C09, 0x3C09, L"3Com NBP Claim NetBIOS name not registered", },
  { 0x3C0A, 0x3C0A, L"3Com NBP Delete Netbios name not registered", },
  { 0x3C0B, 0x3C0B, L"3Com NBP Remote adaptor status request not registered", },
  { 0x3C0C, 0x3C0C, L"3Com NBP Remote adaptor response not registered", },
  { 0x3C0D, 0x3C0D, L"3Com NBP Reset not registered", },
  { 0x4242, 0x4242, L"PCS Basic Block Protocol", },
  { 0x424C, 0x424C, L"Information Modes Little Big LAN diagnostic", },
  { 0x4321, 0x4321, L"THD - Diddle", },
  { 0x4C42, 0x4C42, L"Information Modes Little Big LAN", },
  { 0x6000, 0x6000, L"DEC unassigned, experimental", },
  { 0x6001, 0x6001, L"DEC Maintenance Operation Protocol (MOP) Dump/Load Assistance", },
  { 0x6002, 0x6002, L"DEC Maintenance Operation Protocol (MOP) Remote Console", },
  { 0x6003, 0x6003, L"DECNET Phase IV, DNA Routing", },
  { 0x6004, 0x6004, L"DEC Local Area Transport (LAT)", },
  { 0x6005, 0x6005, L"DEC diagnostic protocol (at interface initialization?)", },
  { 0x6006, 0x6006, L"DEC customer protocol", },
  { 0x6007, 0x6007, L"DEC Local Area VAX Cluster (LAVC), System Communication Architecture (SCA)", },
  { 0x6008, 0x6008, L"DEC AMBER", },
  { 0x6009, 0x6009, L"DEC MUMPS", },
  { 0x6010, 0x6014, L"3Com Corporation", },
  { 0x7000, 0x7000, L"Ungermann-Bass download", },
  { 0x7001, 0x7001, L"Ungermann-Bass NIUs", },
  { 0x7002, 0x7002, L"Ungermann-Bass diagnostic/loopback", },
  { 0x7003, 0x7003, L"Ungermann-Bass ??? (NMC to/from UB Bridge)", },
  { 0x7005, 0x7005, L"Ungermann-Bass Bridge Spanning Tree", },
  { 0x7007, 0x7007, L"OS/9 Microware", },
  { 0x7009, 0x7009, L"OS/9 Net?", },
  { 0x7020, 0x7029, L"LRT (England) (now Sintrom)", },
  { 0x7030, 0x7030, L"Racal-Interlan", },
  { 0x7031, 0x7031, L"Prime NTS (Network Terminal Service)", },
  { 0x7034, 0x7034, L"Cabletron", },
  { 0x8003, 0x8003, L"Cronus VLN", },
  { 0x8004, 0x8004, L"Cronus Direct", },
  { 0x8005, 0x8005, L"HP Probe protocol", },
  { 0x8006, 0x8006, L"Nestar", },
  { 0x8008, 0x8008, L"AT&T/Stanford Univ.     Local use", },
  { 0x8010, 0x8010, L"Excelan", },
  { 0x8013, 0x8013, L"Silicon Graphics diagnostic", },
  { 0x8014, 0x8014, L"Silicon Graphics network games", },
  { 0x8015, 0x8015, L"Silicon Graphics reserved", },
  { 0x8016, 0x8016, L"Silicon Graphics XNS NameServer, bounce server", },
  { 0x8019, 0x8019, L"Apollo DOMAIN", },
  { 0x802E, 0x802E, L"Tymshare", },
  { 0x802F, 0x802F, L"Tigan, Inc.", },
  { 0x8035, 0x8035, L"Reverse Address Resolution Protocol (RARP)", },
  { 0x8036, 0x8036, L"Aeonic Systems", },
  { 0x8037, 0x8037, L"IPX (Novell Netware?)", },
  { 0x8038, 0x8038, L"DEC LanBridge Management", },
  { 0x8039, 0x8039, L"DEC DSM/DDP", },
  { 0x803A, 0x803A, L"DEC Argonaut Console", },
  { 0x803B, 0x803B, L"DEC VAXELN", },
  { 0x803C, 0x803C, L"DEC DNS Naming Service", },
  { 0x803D, 0x803D, L"DEC Ethernet CSMA/CD Encryption Protocol", },
  { 0x803E, 0x803E, L"DEC Distributed Time Service", },
  { 0x803F, 0x803F, L"DEC LAN Traffic Monitor Protocol", },
  { 0x8040, 0x8040, L"DEC PATHWORKS DECnet NETBIOS Emulation", },
  { 0x8041, 0x8041, L"DEC Local Area System Transport", },
  { 0x8042, 0x8042, L"DEC unassigned", },
  { 0x8044, 0x8044, L"Planning Research Corp.", },
  { 0x8046, 0x8046, L"AT&T", },
  { 0x8047, 0x8047, L"AT&T", },
  { 0x8048, 0x8048, L"DEC Availability Manager for Distributed Systems DECamds (but someone at DEC says not)", },
  { 0x8049, 0x8049, L"ExperData", },
  { 0x805B, 0x805B, L"VMTP (Versatile Message Transaction Protocol, RFC-1045) (Stanford) [was Stanford V Kernel, experimental]", },
  { 0x805C, 0x805C, L"Stanford V Kernel, version 6.0", },
  { 0x805D, 0x805D, L"Evans & Sutherland", },
  { 0x8060, 0x8060, L"Little Machines", },
  { 0x8062, 0x8062, L"Counterpoint Computers", },
  { 0x8065, 0x8065, L"University of Mass. at Amherst", },
  { 0x8066, 0x8066, L"University of Mass. at Amherst", },
  { 0x8067, 0x8067, L"Veeco Integrated Automation", },
  { 0x8068, 0x8068, L"General Dynamics", },
  { 0x8069, 0x8069, L"AT&T", },
  { 0x806A, 0x806A, L"Autophon", },
  { 0x806C, 0x806C, L"ComDesign", },
  { 0x806D, 0x806D, L"Compugraphic Corporation", },
  { 0x806E, 0x8077, L"Landmark Graphics Corporation", },
  { 0x807A, 0x807A, L"Matra", },
  { 0x807B, 0x807B, L"Dansk Data Elektronik", },
  { 0x807C, 0x807C, L"Merit Internodal (or Univ of Michigan?)", },
  { 0x807D, 0x807F, L"Vitalink Communications", },
  { 0x8080, 0x8080, L"Vitalink TransLAN III Management", },
  { 0x8081, 0x8083, L"Counterpoint Computers", },
  { 0x8088, 0x808A, L"Xyplex", },
  { 0x809B, 0x809B, L"EtherTalk (AppleTalk over Ethernet)", },
  { 0x809C, 0x809E, L"Datability", },
  { 0x809F, 0x809F, L"Spider Systems Ltd.", },
  { 0x80A3, 0x80A3, L"Nixdorf Computers", },
  { 0x80A4, 0x80B3, L"Siemens Gammasonics Inc.", },
  { 0x80C0, 0x80C3, L"DCA (Digital Comm. Assoc.) Data Exchange Cluster", },
  { 0x80C6, 0x80C6, L"Pacer Software", },
  { 0x80C7, 0x80C7, L"Applitek Corporation", },
  { 0x80C8, 0x80CC, L"Intergraph Corporation", },
  { 0x80CD, 0x80CE, L"Harris Corporation", },
  { 0x80CF, 0x80D2, L"Taylor Instrument", },
  { 0x80D3, 0x80D4, L"Rosemount Corporation", },
  { 0x80D5, 0x80D5, L"IBM SNA Services over Ethernet", },
  { 0x80DD, 0x80DD, L"Varian Associates", },
  { 0x80DE, 0x80DF, L"TRFS (Integrated Solutions Transparent Remote File System)", },
  { 0x80E0, 0x80E3, L"Allen-Bradley", },
  { 0x80E4, 0x80F0, L"Datability", },
  { 0x80F2, 0x80F2, L"Retix", },
  { 0x80F3, 0x80F3, L"AppleTalk Address Resolution Protocol (AARP)", },
  { 0x80F4, 0x80F5, L"Kinetics", },
  { 0x80F7, 0x80F7, L"Apollo Computer", },
  { 0x80FF, 0x8101, L"Wellfleet Communications", },
  { 0x8102, 0x8102, L"Wellfleet; BOFL (Breath OF Life) pkts [every 5-10 secs.]", },
  { 0x8103, 0x8103, L"Wellfleet Communications", },
  { 0x8107, 0x8109, L"Symbolics Private", },
  { 0x812B, 0x812B, L"Talaris", },
  { 0x8130, 0x8130, L"Waterloo Microsystems Inc.", },
  { 0x8131, 0x8131, L"VG Laboratory Systems", },
  { 0x8137, 0x8137, L"Novell (old) NetWare IPX (ECONFIG E option)", },
  { 0x8138, 0x8138, L"Novell, Inc.", },
  { 0x8139, 0x813D, L"KTI", },
  { 0x813F, 0x813F, L"M/MUMPS data sharing", },
  { 0x8145, 0x8145, L"Vrije Universiteit (NL)         Amoeba 4 RPC (obsolete)", },
  { 0x8146, 0x8146, L"Vrije Universiteit (NL)         FLIP (Fast Local Internet Protocol)", },
  { 0x8147, 0x8147, L"Vrije Universiteit (NL)         [reserved]", },
  { 0x814C, 0x814C, L"SNMP over Ethernet (see RFC1089)", },
  { 0x814F, 0x814F, L"Technically Elite Concepts      Network Professor", },
  { 0x8191, 0x8191, L"PowerLAN                        NetBIOS/NetBEUI (PC)", },
  { 0x817D, 0x817D, L"XTP", },
  { 0x81D6, 0x81D7, L"Artisoft Lantastic", },
  { 0x8203, 0x8205, L"QNX Software Systems Ltd.", },
  { 0x8390, 0x8390, L"Accton Technologies (unregistered)", },
  { 0x852B, 0x852B, L"Talaris multicast", },
  { 0x8582, 0x8582, L"Kalpana", },
  { 0x86DD, 0x86DD, L"IP version 6", },
  { 0x8739, 0x8739, L"Control Technology Inc.         RDP Without IP", },
  { 0x873A, 0x873A, L"Control Technology Inc.         Mcast Industrial Ctrl Proto.", },
  { 0x873B, 0x873B, L"Control Technology Inc.         Proprietary", },
  { 0x873C, 0x873C, L"Control Technology Inc.         Proprietary", },
  { 0x8820, 0x8820, L"Hitachi Cable (Optoelectronic Systems Laboratory)", },
  { 0x8856, 0x8856, L"Axis Communications AB          proprietary bootstrap/config", },
  { 0x8888, 0x8888, L"HP LanProbe test?", },
  { 0x9000, 0x9000, L"Loopback (Configuration Test Protocol)", },
  { 0x9001, 0x9001, L"3Com (Formerly Bridge Communications), XNS Systems Management", },
  { 0x9002, 0x9002, L"3Com (Formerly Bridge Communications), TCP/IP Systems Management", },
  { 0x9003, 0x9003, L"3Com (Formerly Bridge Communications), loopback detection", },
  { 0xAAAA, 0xAAAA, L"DECNET?         Used by VAX 6220 DEBNI", },
  { 0xFAF5, 0xFAF5, L"Sonix Arpeggio", },
};

static const SEtherType not_found = { 0xffff, 0xffff, L"" };

#define EtherTypeTableSize (sizeof(etypes)/sizeof(etypes[0]))

int GetEtherTypeTableSize() { return EtherTypeTableSize; }

const SEtherType* GetEtherType(int i)
{
	return (i >= EtherTypeTableSize || i < 0) ? NULL : &etypes[i];
}

const SEtherType& SearchEtherType(WORD w) { 
  int m;
  int l = 0;
  int r = EtherTypeTableSize - 1;
  while (l < r)
    {
      m = (l + r) / 2;
      if (etypes[m].wLow > w)
	{
	  r = m;
	  continue;
	}
      if (etypes[m].wHigh < w)
	{
	  l = m + 1;
	  continue;
	}
      return etypes[m];
    }
  if (etypes[m].wLow <= w && etypes[m].wHigh >= w) return etypes[m];
  return not_found;
}

LPCOLESTR GetEtherTypeString(LPBYTE pb)
{
	// Convert to network byte order
  WORD w = (*(pb + 12) << 8) | *(pb + 13);
  if (w == ET_IP) return etypes[2].pDesc;
  if (w == ET_ARP) return etypes[8].pDesc;
  const SEtherType& s = SearchEtherType(w);
  return s.pDesc;
}
