//---------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#pragma hdrstop

#ifndef COUNTOF
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
#endif

#include "IPFiltersetting.h"
#include "FreePeekStrs.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TIPFilterDlg *IPFilterDlg;
//---------------------------------------------------------------------
__fastcall TIPFilterDlg::TIPFilterDlg(TComponent* AOwner)
	: TForm(AOwner)
{
    SetDirection(false);
}
//---------------------------------------------------------------------
void TIPFilterDlg::SetDirection(bool f)
{
    DestinationGroup->Visible = f;
}
//---------------------------------------------------------------------
void __fastcall TIPFilterDlg::TabControlChange(TObject *Sender)
{
    struct tabInfo {
        TStringList* pList;
        bool fVisible;
    } TabInfo[] = {
        { listProtocol, false, } ,
        { listTCP, true, },
        { listUDP, true, },
    };

    ComboBox->Clear();
    for (int i = 0; i < COUNTOF(TabInfo); i++)
    {
        if (TabControl->TabIndex == i)
        {
            SetDirection(TabInfo[i].fVisible);
            ComboBox->Items = TabInfo[i].pList;
            break;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TIPFilterDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
    static const _FilterTypeConstants ftypes[] =
    {
      FT_PROTOCOL,
      FT_TCPPORT,
      FT_UDPPORT,
    };
	if (ModalResult == mrOk)
	{
        CanClose = false;
        int n = ComboBox->ItemIndex;
        resultString = TabControl->Tabs->Strings[TabControl->TabIndex] + ":";
        if (n >= 0)
        {
            result = reinterpret_cast<int>(ComboBox->Items->Objects[n]);
            resultString += ComboBox->Items->Strings[n];
        }
        else
        {
            try
            {
                result = ComboBox->Text.ToInt();
            }
            catch (const Exception &E)
            {
    			MessageDlg(LoadStr(rsDigitOnly), mtError, TMsgDlgButtons() << mbOK, 0);
                return;
            }
            resultString += ComboBox->Text;
        }

        for (int i = 0; i < COUNTOF(ftypes) ;i++)
        {
            if (TabControl->TabIndex == i)
            {
                ftype = ftypes[i];
                direction = DestinationGroup->ItemIndex;
                break;
            }
        }
        CanClose = true;
	}
}
//---------------------------------------------------------------------------

