#include <stdio.h>
#include <string.h>
#include <ctype.h>

int main(int argc, char* argv[])
{
  char sz[1024];
  if (argc != 3)
    {
      fprintf(stderr, "Usage: htmlconv info.html dest.txt\n");
      return 1;
    }
  FILE* fsrc = fopen(argv[1], "r");
  if (fsrc == NULL)
    {
      fprintf(stderr, "%s was not found\n", argv[1]);
      return 2;
    }
  FILE* fdst = fopen(argv[2], "w");
  if (fdst == NULL)
    {
      fprintf(stderr, "%s was not created\n", argv[2]);
      return 3;
    }

  bool fstart(false), fvalid(false);
  while (fgets(sz, sizeof(sz), fsrc))
    {
      if (fstart == false)
	{
	  if (strncmp(sz, "<PRE>", 5) == 0)
	    fstart = true;
	}
      else
	{
	  if (strncmp(sz, "</PRE>", 6) == 0)
	    break;
	  fvalid = true;
	  for (int i = 0; i < 6; i++)
	    {
	      if (!isxdigit(sz[i]))
		{
		  fvalid = false;
		  break;
		}
	    }
	  if (fvalid == false) continue;
	  fprintf(fdst, "  { 0x%.6s, L\"", sz);
	  bool fskip(false);
	  char* p = &sz[6];
	  while (isspace(*p)) p++;
	  for (; *p && *p != '\n'; p++)
	    {
	      if (fskip)
		{
		  if (isspace(*p)) continue;
		  fskip = false;
		}

	      if (isspace(*p))
		{
		  fskip = true;
		  fputc(' ', fdst);
		}
	      else
		{
		  if (strchr("\\\"\'\?", *p))
		    fputc('\\', fdst);
		  fputc(*p, fdst);
		}
	    }
	  fputs("\", },\n", fdst);
	}
    }
  fclose(fdst);
  fclose(fsrc);
  return 0;
}

