/*
 NCapDD.h - NDIS Capture kernel-mode driver

 Free software Copyright (c) 1999-2000 arton

*/

#ifndef NCAPDD_HEADER__
#define  NCAPDD_HEADER__

#if DBG
#define DebugPrint(_x_) \
                DbgPrint("NCapDD: ");\
                DbgPrint _x_;

#else

#define DebugPrint(_x_) 

#endif

#define MAX_REQUESTS 4
#define  ETHERNET_HEADER_LENGTH   14
#define  TRANSMIT_PACKETS    16

typedef struct _CapTimestamp {
  ULONGLONG Reserved;
  ULONGLONG timeRecved;
} CapTimestamp, *pCapTimestamp;

typedef struct _CapReserved   { // must be <= 16 bytes for receive packet
  LIST_ENTRY ListElement;
  PIRP Irp;
  PMDL pMdl;
}
CapReserved, *PCapReserved;

#define RESERVED(_p) ((PCapReserved)((_p)->ProtocolReserved))

typedef struct _CapRequest
{
  LIST_ENTRY ListElement;
  PIRP Irp;
  NDIS_REQUEST Request;
} CapRequest, *PCapRequest;
/*
  Device extension
*/

/*
  Port device extension.  The symbolicLink buffer points
  into the deviceName buffer, so it mustn't be freed.
*/

typedef struct _DeviceExtension {
    PDEVICE_OBJECT DeviceObject;

    NDIS_HANDLE    NdisProtocolHandle;

    NDIS_STRING    AdapterName;

    PWSTR          BindString;
    PWSTR          ExportString;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

typedef struct _OpenInstance
{
    PDEVICE_EXTENSION   DeviceExtension;

    NDIS_HANDLE    AdapterHandle;

    NDIS_HANDLE         PacketPool;

    KSPIN_LOCK          RcvQSpinLock;
    LIST_ENTRY          RcvList;

    PIRP                OpenCloseIrp;

    NDIS_SPIN_LOCK      RequestSpinLock;
    LIST_ENTRY          RequestList;

    LIST_ENTRY          ResetIrpList;

    CapRequest          Requests[MAX_REQUESTS];

    UCHAR MacAddress[MacAddressSize];
    NDIS_STATUS MacAddressReqStatus;
    NDIS_STATUS SetFilterReqStatus;
} OPEN_INSTANCE, *POPEN_INSTANCE;
#endif
