// Copyright(c) 1999 arton

#ifndef __PACKETCOLLECTION_H_
#define __PACKETCOLLECTION_H_

#include "resource.h" 

class CMacCapture;
/////////////////////////////////////////////////////////////////////////////
// CPacketCollection
class ATL_NO_VTABLE CPacketCollection : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPacketCollection, &CLSID_PacketCollection>,
	public IDispatchImpl<IPacketCollection, &IID_IPacketCollection, &LIBID_MACCAPV2Lib, MACCAPLIB_MJ>
{
public:
	CPacketCollection(long n = -1) : m_cbPackets(n)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PACKETCOLLECTION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CPacketCollection)
	COM_INTERFACE_ENTRY(IPacketCollection)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

	void FinalRelease()
	{
		m_pStm->Release();
	}

	inline void SetStream(IStream* p)
	{
		p->AddRef();
		m_pStm = p;
	}
// IPacketCollection
public:
	HRESULT STDMETHODCALLTYPE get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppUnk);

	HRESULT STDMETHODCALLTYPE get_Length( 
            /* [retval][out] */ long __RPC_FAR *pResult);
private:
	IStream* m_pStm;
	long m_cbPackets;
};

#endif //__PACKETCOLLECTION_H_
