// Copyright(c) 1999 arton	

#ifndef __PROTOCOLNAMECOLLECTION_H_
#define __PROTOCOLNAMECOLLECTION_H_

#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CProtocolNameCollection
class ATL_NO_VTABLE CProtocolNameCollection : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CProtocolNameCollection, &CLSID_ProtocolNameCollection>,
	public IObjectSafetyImpl<CProtocolNameCollection, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public IDispatchImpl<IProtocolNameCollection, &IID_IProtocolNameCollection, &LIBID_MACCAPV2Lib, MACCAPLIB_MJ>
{
public:
	CProtocolNameCollection()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PROTOCOLNAMECOLLECTION)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CProtocolNameCollection)
	COM_INTERFACE_ENTRY(IProtocolNameCollection)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectSafety)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// IProtocolNameCollection
public:
public:
	HRESULT STDMETHODCALLTYPE get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppUnk);

	HRESULT STDMETHODCALLTYPE get_Length( 
            /* [retval][out] */ long __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE Find( 
            /* [in] */ long Proto,
            /* [retval][out] */ BSTR __RPC_FAR *pResult);
};

#endif //__PROTOCOLNAMECOLLECTION_H_
