//--------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#pragma hdrstop
#include <ctype.h>
#include "ValOffset.h"
#include "FreePeekStrs.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TValOffsetDlg *ValOffsetDlg;
//---------------------------------------------------------------------
__fastcall TValOffsetDlg::TValOffsetDlg(TComponent* AOwner)
	: TForm(AOwner)
{
    struct WellKnownOffset {
        const char* name;
        int offset;
    } wktbl[] = {
        { "Ehternet Header", 0 },
        { "IP Header", 14 },
        { "TCP Header", 34 },
        { "UDP Header", 34 },
        { "UDP Data", 42 },
        { "TCP Data", 54 },
    };
    for (int i = 0; i < COUNTOF(wktbl); i++)
    {
        ComboOffset->Items->AddObject(wktbl[i].name, reinterpret_cast<TObject*>(wktbl[i].offset));
    }
    ComboOffset->ItemIndex = 0;
    Height = SHRINKED_HEIGHT;
    ComboCode->ItemIndex = 0;
    for (int i = 1; i <= 16; i++)
    {
        char sz[8];
        wsprintf(sz, "%02X", i - 1);
        CodeGrid->Cells[0][i] = sz;
        CodeGrid->Cells[i][0] = sz;
    }
    SetCodes(0);
}
//---------------------------------------------------------------------
void TValOffsetDlg::SetCodes(int index)
{
    static const char* ascs[2][16][16] = {
      {
        { "NUL", "SOH", "STX", "ETX", "EOT", "ENQ", "ACK", "BEL", "BS", "HT", "LF", "VT", "FF", "CR", "SO", "SI", },
        { "DLE", "DC1", "DC2", "DC3", "DC4", "NAK", "SYN", "ETB", "CAN", "EM", "SUB", "ESC", "FS", "GS", "RS", "US", },
        { "SPC", " !", " \"", " #", " $", " %", " &", " '", " (", " )", " *", " +", " ,", " -", " .", " /", },
        { " 0", " 1", " 2", " 3", " 4", " 5", " 6", " 7", " 8", " 9", " :", " ;", " <", " =", " >", " ?", },
        { " @", " A", " B", " C", " D", " E", " F", " G", " H", " I", " J", " K", " L", " M", " N", " O", },
        { " P", " Q", " R", " S", " T", " U", " V", " W", " X", " Y", " Z", " [", " \\", " ]", " ^", " _", },
        { "", " a", " b", " c", " d", " e", " f", " g", " h", " i", " j", " k", " l", " m", " n", " o", },
        { " p", " q", " r", " s", " t", " u", " v", " w", " x", " y", " z", " {", " |", " }", " ~", "DEL", },
        { "", "", "BPH", "NBH", "IND", "NEL", "SSA", "ESA", "HTS", "HTJ", "VTS", "PLD", "PLU", "RI", "SS2", "SS3", },
        { "DCS", "PU1", "PU2", "STS", "CCH", "MW", "SPA", "EPA", "SOS", "", "SCI", "CSI", "ST", "OSC", "PM", "APC", },
        { "", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", },
        { " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", },
        { " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", },
        { " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", },
        { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", },
        { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", },
      },
      { 
        { "NUL", "SOH", "STX", "ETX", "SEL", "HT", "RNL", "DEL", "GE", "SPS", "RPT", "VT", "FF", "CR", "SO", "SI", },
        { "DLE", "DC1", "DC2", "DC3", "RES", "NL", "BS", "POC", "CAN", "EM", "UBS", "CU1", "IFS", "IGS", "IRS", "IUS", },
        { "DS", "SOS", "FS", "WUS", "BYP", "LF", "ETB", "ESC", "SA", "SFE", "SM", "CSP", "MFA", "ENQ", "ACK", "BEL", },
        { "", "", "SYN", "IR", "PP", "TRN", "NBS", "EOT", "SBS", "IT", "RFF", "CU3", "DC4", "NAK", "", "SUB", },
        { "SPC", " ", " ", " ", " ", " ", " ", " ", " ", " ", "", " .", " <", " (", " +", " |", },
        { "&", " ", " ", " ", " ", " ", " ", "", " ", "", " !", " \\", " *", " )", " ;", "", },
        { " -", " /", "", "", "", "", "", "", "", "", "", " ,", " %", " _", " >", " ?", },
        { "", "", "", "", "", "", "", "", "", "", " :", " #", " @", " '", " =", " \"", },
        { "", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", "", " ", " ", " ", " ", },
        { " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", "", "", " ", " ", " ", },
        { "", " ~", " ", " ", " ", " ", " ", " ", " ", " ", " ", "", " ", " ", " ", " ", },
        { "", "", "", "", "", "", "", "", "", "", " ", " ", " ", " ", " ", " ", },
        { "", " A", " B", " C", " D", " E", " F", " G", " H", " I", "", "", "", "", "", "", },
        { "", " J", " K", " L", " M", " N", " O", " P", " Q", " R", "", "", "", "", "", "", },
        { " $", "", " S", " T", " U", " V", " W", " X", " Y", " Z", "", "", "", "", "", "", },
        { " 0", " 1", " 2", " 3", " 4", " 5", " 6", " 7", " 8", " 9", "", "", "", "", "", "", },
      },
    };
    for (int i = 1; i <= 16; i++)
    {
        for (int j = 1; j <= 16; j++)
        {
            CodeGrid->Cells[j][i] = ascs[index][i - 1][j - 1];
        }
    }
}
//---------------------------------------------------------------------
void __fastcall TValOffsetDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
	if (ModalResult == mrOk)
    {
        CanClose = false;
        if (EditOffset->Text.Length() <= 0)
            offsetValue = 0;
        else
            offsetValue = StrToInt(EditOffset->Text);
        offsetValue += reinterpret_cast<int>(ComboOffset->Items->Objects[ComboOffset->ItemIndex]);
        AnsiString& s = EditValue->Text;
        if (s.Length() <= 0)
        {
            MessageDlg(LoadStr(rsNoInput), mtError, TMsgDlgButtons() << mbOK, 0);
            return;
        }
        if (s.Length() & 1)
        {
            MessageDlg(LoadStr(rsELength), mtError, TMsgDlgButtons() << mbOK, 0);
            return;
        }
        for (int i = 1; i <= s.Length(); i++)
        {
            if (isxdigit(s[i]) == false)
            {
                MessageDlg(LoadStr(rsXDigitOnly), mtError, TMsgDlgButtons() << mbOK, 0);
                return;
            }
        }
        DataValue = s.UpperCase();
    }
    CanClose = true;
}
//---------------------------------------------------------------------------
void __fastcall TValOffsetDlg::ButtonExpandClick(TObject *Sender)
{
    if (Height == EXPANDED_HEIGHT)
    {
        Height = SHRINKED_HEIGHT;
        ButtonExpand->Caption = ">>";
    }
    else
    {
        Height = EXPANDED_HEIGHT;
        ButtonExpand->Caption = "<<";
    }
}
//---------------------------------------------------------------------------
void __fastcall TValOffsetDlg::ComboCodeChange(TObject *Sender)
{
    SetCodes(ComboCode->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TValOffsetDlg::CodeGridDblClick(TObject *Sender)
{
    if (CodeGrid->Row <= 0 || CodeGrid->Col <= 0) return;
    char sz[8];
    wsprintf(sz, "%X%X", CodeGrid->Row - 1, CodeGrid->Col - 1);
    EditValue->SelText = sz;    
}
//---------------------------------------------------------------------------

