// Copyright(c) 1999 arton	

#ifndef __VENDERS_H_
#define __VENDERS_H_

#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CVendors
class ATL_NO_VTABLE CVendors : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CVendors, &CLSID_VendorCollectionEx>,
	public IObjectSafetyImpl<CVendors, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public IDispatchImpl<IVendorCollectionEx, &IID_IVendorCollectionEx, &LIBID_MACCAPV2Lib, MACCAPLIB_MJ>
{
public:
	CVendors()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_VENDERS)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CVendors)
	COM_INTERFACE_ENTRY(IVendorCollectionEx)
	COM_INTERFACE_ENTRY(IVendorCollection)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectSafety)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// IVendorCollection
public:
	HRESULT STDMETHODCALLTYPE get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppUnk);
        
	HRESULT STDMETHODCALLTYPE get_Length( 
            /* [retval][out] */ long __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE Find( 
            /* [in] */ long Proto,
            /* [retval][out] */ BSTR __RPC_FAR *pResult);

// IVendorCollectionEx
	HRESULT STDMETHODCALLTYPE get_Item( 
            /* [in] */ long index,
            /* [retval][out] */ INameValuePair __RPC_FAR *__RPC_FAR *ppRetVal);

};

#endif //__VENDERS_H_
