//---------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#pragma hdrstop

#include "ip.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
static const char* ICMPTypes[] = {
		"Echo Reply",//                              [RFC792]
		"Unassigned",//                              [JBP]
		"Unassigned",//                              [JBP]
		"Destination Unreachable",//                 [RFC792]
		"Source Quench",//                           [RFC792]
		"Redirect (chage route)", //                 [RFC792]
		"Alternate Host Address",//                  [JBP]
		"Unassigned",//                              [JBP]
		"Echo Request",//                            [RFC792]
		"Router Advertisement",//                    [RFC1256]
		"Router Selection",//                        [RFC1256]
		"Time Exceeded",//                           [RFC792]
		"Parameter Problem",//                       [RFC792]
		"Timestamp",//                               [RFC792]
		"Timestamp Reply",//                         [RFC792]
		"Information Request",//                     [RFC792]
		"Information Reply",//                       [RFC792]
		"Address Mask Request",//                    [RFC950]
		"Address Mask Reply",//                      [RFC950]
		"Reserved (for Security)",//                 [Solo]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Reserved (for Robustness Experiment)",//    [ZSu]
		"Traceroute",//                              [RFC1393]
		"Datagram Conversion Error",//               [RFC1475]
		"Mobile Host Redirect",//              [David Johnson]
		"IPv6 Where-Are-You",//                 [Bill Simpson]
		"IPv6 I-Am-Here",//                     [Bill Simpson]
		"Mobile Registration Request",//        [Bill Simpson]
		"Mobile Registration Reply",//          [Bill Simpson]
};

LPCSTR GetICMPTypeName(BYTE b)
{
	if (b <= COUNTOF(ICMPTypes))
		return ICMPTypes[b];
	else
		return "";
}

//---------------------------------------------------------------------------
AnsiString GetUDPInfo(LPBYTE pb)
{
	char sz[128];
	short ds = ntohs(pb + sizeof(short));
	short ss = ntohs(pb);
	LPCTSTR ps = AssPort::SearchUDPPort(ss);
	LPCTSTR pd = AssPort::SearchUDPPort(ds);
	wsprintf(sz, "%d-%d", ss, ds);
	AnsiString as(sz);
	if (ps || pd)
	{
		as += "(";
		as += (ps) ? ps : pd;
		as += ")";
	}
	return as;
}
//---------------------------------------------------------------------------
AnsiString GetTCPInfo(LPBYTE pb)
{
	char sz[64];
	short ds = ntohs(pb + sizeof(short));
	short ss = ntohs(pb);
	LPCTSTR ps = AssPort::SearchTCPPort(ss);
	LPCTSTR pd = AssPort::SearchTCPPort(ds);
	wsprintf(sz, "%d-%d", ss, ds);
	AnsiString as(sz);
	if (ps || pd)
	{
		as += "(";
		as += (ps) ? ps : pd;
		as += ") ";
	}
	else
	{
		as += " ";
	}
	BYTE b = *(pb + 13);
	if (b & TCP_SYN)
		as += "SYN ";
	if (b & TCP_RST)
		as += "RST ";
	if (b & TCP_FIN)
		as += "FIN ";
	if (b & TCP_PSH)
		as += "PSH ";
	if (b & TCP_URG)
		as += "URG ";
	if (b & TCP_ACK)
		as += "ACK ";
	return as.TrimRight();
}
//---------------------------------------------------------------------------
static const char* OSPFTypes[] = {
	"Unknown",
	"Hello",
	"Database Description",
	"Link State Request",
	"Link State Update",
	"Link State Acknowledgment",
};

AnsiString GetOSPFInfo(LPBYTE pb)
{
	BYTE b = *(pb + 1);
	if (b >= COUNTOF(OSPFTypes))
		return "Unknown";
	else
		return OSPFTypes[b];
}
//---------------------------------------------------------------------------


