/*
 Free Soft - Copyright (c) 1999 arton
*/
#ifndef _NCAP_HEADER
#define _NCAP_HEADER

#include <ntddndis.h>

#include <devioctl.h>

#define        MAX_LINK_NAME_LENGTH   124

typedef struct _PACKET_OID_DATA {

    ULONG           Oid;
    ULONG           Length;
    UCHAR           Data[1];

}   PACKET_OID_DATA, *PPACKET_OID_DATA;

#ifndef FILE_DEVICE_UNKNOWN
#define FILE_DEVICE_UNKNOWN 0x00000022
#endif

#define FILE_DEVICE_PROTOCOL        0x8000

#define MacAddressSize 6

enum {
  FnCode_CAPGetMacAddress,
  FnCode_CAPGetTick,
  FnCode_CAPSetOID,
  FnCode_CAPQueryOID,
  FnCode_CAPReset,
  FnCode_CAPEnumAdapters,
};

enum {
  DIOC_CAPGetMacAddress = 
      CTL_CODE(FILE_DEVICE_UNKNOWN, FnCode_CAPGetMacAddress,
	       METHOD_BUFFERED, FILE_ANY_ACCESS),
  DIOC_CAPGetTick = 
      CTL_CODE(FILE_DEVICE_UNKNOWN, FnCode_CAPGetTick,
	       METHOD_BUFFERED, FILE_ANY_ACCESS),
  IOCTL_PROTOCOL_SET_OID =
      CTL_CODE(FILE_DEVICE_PROTOCOL, FnCode_CAPSetOID,
	       METHOD_BUFFERED, FILE_ANY_ACCESS),
  IOCTL_PROTOCOL_QUERY_OID =
      CTL_CODE(FILE_DEVICE_PROTOCOL, FnCode_CAPQueryOID,
	       METHOD_BUFFERED, FILE_ANY_ACCESS),
  IOCTL_PROTOCOL_RESET =
      CTL_CODE(FILE_DEVICE_PROTOCOL, FnCode_CAPReset ,
	       METHOD_BUFFERED, FILE_ANY_ACCESS),
  IOCTL_ENUM_ADAPTERS =
      CTL_CODE(FILE_DEVICE_PROTOCOL, FnCode_CAPEnumAdapters,
	       METHOD_BUFFERED, FILE_ANY_ACCESS)  
};

#endif


